// IMA　ADPCM typedef

typedef struct {  /* Decoder work area of an IMA-ADPCM stream */
  int16_t val;  /* Previous sample value (-32768..32768) */
  uint8_t idx;  /* Current index of step size (0..88) */
} IMADEC;


int16_t ima_decode(  /* Returns the sample value (-32768 to 32767) */
  IMADEC* ad,     /* Work area for the ADPCM stream */
  uint8_t dat,    /* ADPCM data, b3:sign (0:+, 1:-), b2-b0:magnify (0..7) */
  uint8_t hl      /* High or low data read */
);

